#######################
#~Script Date By MiB!~#
#######################
import es
import cmdlib
import gamethread
import os
import zipfile
import urllib2
import psyco
psyco.full()

info = es.AddonInfo()
info["name"] = "Script Date"
info["basename"] = "scriptdate"
info["version"] = "0.2 BETA"
info["authors"] = "MiB"
info["url"] = "http://www.sddcommunity.com"
info["description"] = "Checks script versions."
pv = es.ServerVar("scriptdate_version")
pv.set(info["version"])
pv.makepublic()
addons = {}
basedir = str(es.ServerVar("eventscripts_gamedir")) + "/"

def load():
    cmdlib.registerServerCommand("scriptdate_add_list",__cmd_add_list,"[Script Date] scriptdate_add_list <basename> <current version var> <auto update> <url to version files>")
    cmdlib.registerServerCommand("scriptdate_remove_list",__cmd_remove_list,"[Script Date] scriptdate_remove_list <basename>")
    cmdlib.registerServerCommand("scriptdate_check_list",__cmd_check_list,"[Script Date] scriptdate_check_list <basename> <return var>")

def unload():
    cmdlib.unregisterServerCommand("scriptdate_add_list")
    cmdlib.unregisterServerCommand("scriptdate_remove_list")
    cmdlib.unregisterServerCommand("scriptdate_check_list")

def es_map_start(ev):
    es.dbgmsg(0,"[Script Date] Checking all addon versions in addons dictionary....")
    try:
        if len(addons) > 0:
            for basename in addons:
                cversion = str(addons[basename]["version"])
                if cversion.isdigit(): cversion = int(cversion)
                update = __inter(basename)
                if update.getVersion() != cversion:
                    if addons[basename]["update"] == 1:
                        es.dbgmsg(0,"[Script Date] Addon %s is not the current version, script is being updated now...."%basename)
                        es.unload(basename)
                        update.Download()
                        es.dbgmsg(0,"[Script Date] Addon %s is now fully updated...."%basename)
                        gamethread.delayed(0.1,es.load,(basename))
                    else: es.dbgmsg(0,"[Script Date] Addon %s is not the current version, please download the current...."%basename)
                else: es.dbgmsg(0,"[Script Date] Addon %s is current version...."%basename)
        es.dbgmsg(0,"[Script Date] Addon versions checking complete....")
    except: es.dbgmsg(0,"[Script Date] Could not finish, checking canceled....")

def add_list(basename,cversion,update,url):
    if not check_list(basename):
        if not url.startswith("http://"): url = "http://" + url
        addons[basename] = {}
        addons[basename]["version"] = es.ServerVar(cversion)
        addons[basename]["update"] = update
        addons[basename]["url"] = url
    else: es.dbgmsg(0,"[Script Date] Addon %s is already in the addons dictionary...."%basename)

def remove_list(basename):
    if check_list(basename): del addons[basename]
    else: es.dbgmsg(0,"[Script Date] Addon %s is not in the addons dictionary...."%basename)

def check_list(basename):
    if basename in addons: return True
    else: return False

def __cmd_add_list(args):
    if len(args) == 4: add_list(args[0],args[1],int(args[2]),args[3])
    else: es.dbgmsg(0,"[Script Date] Number of arguments needed is four....")

def __cmd_remove_list(args):
    if len(args) == 1: remove_list(args[0])
    else: es.dbgmsg(0,"[Script Date] Number of arguments needed is one....")

def __cmd_check_list(args):
    if len(args) == 2:
        if check_list(args[0]): value = 1
        else: value = 0
        sv = es.ServerVar(args[1]).set(value)
    else: es.dbgmsg(0,"[Script Date] Number of arguments needed is two....")

class __inter():
    def __init__(self,url):
        self.url = url
        self.download = addons[self.url]["url"] + self.url + ".zip"
        self.vdownload = addons[self.url]["url"] + self.url + ".txt"
        self.ldownload = basedir + self.url + ".zip"
        self.version = self.__gainver()
    def __gainver(self):
        uf = urllib2.urlopen(self.vdownload)
        uc = uf.read()
        uf.close()
        if uc.isdigit(): uc = int(uc)
        return uc
    def checkFile(self,fp):
        if os.path.exists(fp):
            os.chmod(fp,0777)
            os.remove(fp)
    def getVersion(self):
        return self.version
    def getDownload(self):
        return self.download
    def Download(self):
        self.checkFile(self.ldownload)
        uf = urllib2.urlopen(self.download)
        fd = open(self.ldownload,"wb")
        fd.write(uf.read())
        fd.close()
        uf.close()
        self.Extract()
    def Extract(self):
        zf = zipfile.ZipFile(self.ldownload)
        zo = sorted(zf.namelist())
        for zdir in filter(lambda fil: fil.endswith("/"),zo):
            zfdir = basedir + zdir
            if not os.path.isdir(zfdir): os.mkdir(zfdir)
        for zfile in filter(lambda fil: not fil.endswith("/"),zo):
            zffile = basedir + zfile
            self.checkFile(zffile)
            zwfile = open(zffile,"wb")
            zwfile.write(zf.read(zfile))
            zwfile.close()
        zf.close()
        self.checkFile(self.ldownload)
